/*
				test.c - Data Structure Library	Tester				
<Kenneth Marino>   							<4/18/12>
*/

#include <stdio.h>     
#include <stdlib.h>
#include <string.h>
#include "P4-1.h"


// Example of define element type 
typedef struct 
{
	char	*key;
	double 	MyVar[10];
} MyElement_t;

// Another element
typedef struct
{
	int		key;
	float	value;
	char*	string;
} NewElement_t;

// Function definitions
int MyMatch(void *key, void *Element);
int MyLE(void *Element1, void *Element2);
int NewMatch(void *key, void *Element);
int NewLE(void *Element1, void *Element2);
void printList(void* MyList);
void printNewList(void* MyList);

// Main Program
int main(int argc, char *argv[])
{
	// Create new Linked list of MyElement_t
	void* MyList = CreateLL(sizeof(MyElement_t), MyMatch, MyLE);

	// Create some new elements and assign values
	MyElement_t* A = (MyElement_t *) CreateElement(MyList);
	MyElement_t* B = (MyElement_t *) CreateElement(MyList);
	MyElement_t* C = (MyElement_t *) CreateElement(MyList);
	MyElement_t* D = (MyElement_t *) CreateElement(MyList);
	A->key="AMinor";
	A->MyVar[3]=42.42;
	B->key="BMajor";
	B->MyVar[0]=12.5;
	B->MyVar[1]=77.44;
	C->key="CMinor";
	C->MyVar[8]=4.89;
	D->key="DbMajor";
	D->MyVar[5]=145.9;

	// Insert two of the elements at the head
	printf("Inserting A\n");
	InsertElement(MyList,(void*) A);
	printf("Inserting B\n");
	InsertElement(MyList,(void*) B);

	// Print the list keys
	printList(MyList);

	// Get the head and print the key
	MyElement_t* element = (MyElement_t*) GetFLElement(MyList, 0, 0);	
	printf("Head %s\n", element->key);

	// Get the tail and print the key
	element = (MyElement_t*) GetFLElement(MyList, 1, 0);
	printf("Tail %s\n", element->key);	

	// Remove the tail, and insert a new head
	printf("Removing tail\n");
	GetFLElement(MyList, 1, 1);
	printf("Inserting C\n");
	InsertElement(MyList,(void*) C);

	// Print the list keys
	printList(MyList);

	// Add the rest of the elements on again
	printf("Inserting A\n");
	InsertElement(MyList, (void*) A);
	printf("Inserting D\n");
	InsertElement(MyList, (void*) D);

	// Print the list keys
	printList(MyList);

	// Remove the head
	printf("Removing the Head\n");
	GetFLElement(MyList, 0, 1);

	// Print the list keys
	printList(MyList);

	// Get the tail and print the element before it
	element = (MyElement_t*) GetFLElement(MyList, 1, 0);
	element = Traverse(element, 1);
	printf("Second to last %s\n", element->key);

	// Make sure Traverse for head going backwards gives us NULL
	element = (MyElement_t*) GetFLElement(MyList, 0, 0);
	element = Traverse(element, 1);
	if (element == NULL)
		printf("It's NULL\n");
	else
		printf("It's not NULL\n");

	// Gets C, and prints it
	element = (MyElement_t*) GetElement(MyList, (void*)(C->key), 0);
	printf("C element %s\n", element->key);

	// Print the list keys
	printList(MyList);

	// Removes B and prints the list
	printf("Removing B\n");
	GetElement(MyList, (void*)(B->key), 1);
	printList(MyList);

	// Remove A and C from the list
	printf("Removing A\n");
	GetElement(MyList, (void*)(A->key), 1);
	printf("Removing C\n");
	GetElement(MyList, (void*)(C->key), 1);
	
	// Insert the elements using InsertElementSorted
	printf("Inserting B\n");
	InsertElementSorted(MyList, (void*) B);
	printList(MyList);
	printf("Inserting D\n");
	InsertElementSorted(MyList, (void*) D);
	printList(MyList);
	printf("Inserting A\n");
	InsertElementSorted(MyList, (void*) A);
	printList(MyList);
	printf("Inserting C\n");
	InsertElementSorted(MyList, (void*) C);
	printList(MyList);

	// Remove the elements
	printf("Removing A\n");
	GetElement(MyList, (void*)(A->key), 1);
	printf("Removing B\n");
	GetElement(MyList, (void*)(A->key), 1);
	printf("Removing C\n");
	GetElement(MyList, (void*)(A->key), 1);
	printf("Removing D\n");
	GetElement(MyList, (void*)(A->key), 1);

	// Delete the elements
	printf("Deleting A\n");
	DeleteElement(A);
	printf("Deleting B\n");
	DeleteElement(B);
	printf("Deleting C\n");
	DeleteElement(C);
	printf("Deleting D\n");
	DeleteElement(D);

	// Delete the list
	printf("Deleting the list\n");
	DeleteLL(MyList);

	// Create new LL of type NewElement_t
	void* List2 = CreateLL(sizeof(NewElement_t), NewMatch, NewLE);	

	// Create some new elements
	NewElement_t* E1 = (NewElement_t*)CreateElement(List2);	
	E1->key = 1;
	E1->value = 1.0;
	E1->string = "One";
	NewElement_t* E2 = (NewElement_t*)CreateElement(List2);	
	E2->key = 2;
	E2->value = 2.0;
	E2->string = "Two";
	NewElement_t* E3 = (NewElement_t*)CreateElement(List2);	
	E3->key = 3;
	E3->value = 3.0;
	E3->string = "Three";
	NewElement_t* E4 = (NewElement_t*)CreateElement(List2);	
	E4->key = 4;
	E4->value = 4.0;
	E4->string = "Four";
	NewElement_t* E5 = (NewElement_t*)CreateElement(List2);	
	E5->key = 5;
	E5->value = 5.0;
	E5->string = "Five";
	NewElement_t* E6 = (NewElement_t*)CreateElement(List2);	
	E6->key = 6;
	E6->value = 6.0;
	E6->string = "Six";
	NewElement_t* E7 = (NewElement_t*)CreateElement(List2);	
	E7->key = 7;
	E7->value = 7.0;
	E7->string = "Seven";

	// Insert An element
	InsertElement(List2, E1);
	printf("Inserting 1\n");
	printNewList(List2);
	
	// Get the head
	NewElement_t* newEl = (NewElement_t*)GetFLElement(List2, 0, 0);
	printf("Head key %d\n", newEl->key);

	// Get the tail
	newEl = (NewElement_t*)GetFLElement(List2, 1, 0);
	printf("Tail key %d\n", newEl->key);

	// Insert 3
	InsertElement(List2, E3);
	printf("Inserting 3\n");
	printNewList(List2);

	// Get the head
	newEl = (NewElement_t*)GetFLElement(List2, 0, 0);
	printf("Head key %d\n", newEl->key);

	// Get the tail
	newEl = (NewElement_t*)GetFLElement(List2, 1, 0);
	printf("Tail key %d\n", newEl->key);

	// Removing element 1
	printf("Removing 1\n");
	newEl = (NewElement_t*)GetElement(List2, (void*)&(E1->key), 1);
	printf("Removed element key %d\n", newEl->key);
	printNewList(List2);

	// Removing the tail
	printf("Removing tail\n");
	GetFLElement(List2, 1, 1);

	// Make sure the head is null
	if (GetFLElement(List2, 0, 0) == NULL)
		printf("It's NULL now\n");
	else
		printf("Something went wrong\n");

	// Now insert elements in order
	printf("Inserting 6 in order\n");
	InsertElementSorted(List2, E6);
	printNewList(List2);
	printf("Inserting 2 in order\n");
	InsertElementSorted(List2, E2);
	printNewList(List2);
	printf("Inserting 5 in order\n");
	InsertElementSorted(List2, E5);
	printNewList(List2);
	printf("Inserting 1 in order\n");
	InsertElementSorted(List2, E1);
	printNewList(List2);
	printf("Inserting 4 in order\n");
	InsertElementSorted(List2, E4);
	printNewList(List2);
	printf("Inserting 7 in order\n");
	InsertElementSorted(List2, E7);
	printNewList(List2);
	printf("Inserting 3 in order\n");
	InsertElementSorted(List2, E3);
	printNewList(List2);

	// Get the head
	newEl = (NewElement_t*)GetFLElement(List2, 0, 0);
	printf("Head key %d\n", newEl->key);

	// Traverse and get the next element, then the next
	newEl = (NewElement_t*)Traverse(newEl, 0);
	printf("Next key %d\n", newEl->key);
	newEl = (NewElement_t*)Traverse(newEl, 0);
	printf("Next key %d\n", newEl->key);
	newEl = (NewElement_t*)Traverse(newEl, 0);
	printf("Next key %d\n", newEl->key);

	// Traverse backward and get the previous, then the previous
	newEl = (NewElement_t*)Traverse(newEl, 1);
	printf("Previous key %d\n", newEl->key);	
	newEl = (NewElement_t*)Traverse(newEl, 1);
	printf("Previous key %d\n", newEl->key);	
	newEl = (NewElement_t*)Traverse(newEl, 1);
	printf("Previous key %d\n", newEl->key);	

	// Remove the elements
	printf("Removing 4\n");
	GetElement(List2, (void*)&(E4->key), 1);
	printNewList(List2);
	printf("Removing 3\n");
	GetElement(List2, (void*)&(E3->key), 1);
	printNewList(List2);
	printf("Removing 7\n");
	GetElement(List2, (void*)&(E7->key), 1);
	printNewList(List2);
	printf("Removing 1\n");
	GetElement(List2, (void*)&(E1->key), 1);
	printNewList(List2);
	printf("Removing 2\n");
	GetElement(List2, (void*)&(E2->key), 1);
	printNewList(List2);
	printf("Removing 6\n");
	GetElement(List2, (void*)&(E6->key), 1);
	printNewList(List2);
	printf("Removing 5\n");
	GetElement(List2, (void*)&(E5->key), 1);
	printNewList(List2);

	// Delete the elements
	printf("Deleting 1\n");
	DeleteElement(E1);
	printf("Deleting 2\n");
	DeleteElement(E2);
	printf("Deleting 3\n");
	DeleteElement(E3);
	printf("Deleting 4\n");
	DeleteElement(E4);
	printf("Deleting 5\n");
	DeleteElement(E5);
	printf("Deleting 6\n");
	DeleteElement(E6);
	printf("Deleting 7\n");
	DeleteElement(E7);

	// Delete the list
	printf("Deleting the list\n");
	DeleteLL(List2);

	return(0);
}

// Prints MyElement_t list
void printList(void* MyList)
{
	int count = 0;
	// Get the head
	void* element = (MyElement_t*) GetFLElement(MyList, 0, 0);	

	while(element != NULL)
	{
		count++;
		// Print the element's key
		printf("Element %d %s\n", count, ((MyElement_t*)element)->key);
		element = Traverse(element, 0);
	}
}

// Prints NewElement_t list
void printNewList(void* MyList)
{
	int count = 0;
	// Get the head
	void* element = (NewElement_t*) GetFLElement(MyList, 0, 0);	

	while(element != NULL)
	{
		NewElement_t* PrintEl = (NewElement_t*)element;
		count++;
		// Print the element's key
		printf("Element %d %d %f %s\n", count, PrintEl->key, PrintEl->value, PrintEl->string);
		element = Traverse(element, 0);
	}
}

// Match function defined by user
int MyMatch(void *key, void *Element)
{	
	char* key_char = (char*)key;
	MyElement_t* element_t = (MyElement_t*)Element;
	// Get the element's key
	char* ele_key = element_t->key;
	int compare = strcmp(key_char, ele_key);
	// If strcmp returned 0, then the keys are the same
	if (compare == 0)
		return 1;
	else
		return 0;
}

// Less than or equal to function defined by user
int MyLE(void *Element1, void *Element2)
{
	MyElement_t* element_t1 = (MyElement_t*)Element1;
	MyElement_t* element_t2 = (MyElement_t*)Element2;
	// Get the keys of the elements
	char* ele1_key = element_t1->key;
	char* ele2_key = element_t2->key;
	int compare = strcmp(ele1_key, ele2_key);
	// If strcmp returned a number <= 0, then the first element is <= the second
	if (compare <= 0)
		return 1;
	else
		return 0;
}

// Another match function
int NewMatch(void *key, void *Element)
{
	int key_int = *((int*)key);
	NewElement_t* element_t = (NewElement_t*)Element;
	// Get the element's key
	int ele_key = element_t->key;
	// Checks if they are the same
	if (key_int == ele_key)
		return 1;
	else
		return 0;
}

// Another Less than or Equal function
int NewLE(void *Element1, void *Element2)
{
	NewElement_t* element_t1 = (NewElement_t*)Element1;
	NewElement_t* element_t2 = (NewElement_t*)Element2;
	// Get the keys of the elements
	int ele1_key = element_t1->key;
	int ele2_key = element_t2->key;
	// If the first key is <= the second, return 1, 0 otherwise
	if (ele1_key <= ele2_key)
		return 1;
	else
		return 0;
}
